;;
;;	 |                                        |   
;;	 __|  __| _` | __ \   __| __ `__ \   _` | __| 
;;	 |   |   (   | |   |\__ \ |   |   | (   | |   
;;	\__|_|  \__,_|_|  _|____/_|  _|  _|\__,_|\__| 
;;
;; An attempt at glitch art and sound with an Atari VCS
;;
;; Written by:
;;     TSCHAK
;;	
;; Build this with DASM, -f3 option.
;;

	processor 6502
	include "vcs.h"

	SEG CODE
	ORG $FF80

	;; Equates
	
CLK	EQU	$80   		; Used as simple clock with intim.
SEED	EQU	$83

	;; Clear all memory
	
Init	SEI
	CLD
	LDA #$00
	LDX #$FF
	TXS
Clr	STA #$00,X
	DEX
	BNE Clr
	
	LDX #$84
	INC CLK+1
	
Reset	LDA #$40
	STA T1024T
Top	LDA CLK+0
	ORA CLK+1
	AND #$3F		; Keep within TIA regs
	TAY
	LDA CLK+0
	ORA CLK+1
	STA $09,Y		; on top of the video TIA regs
	LDX CLK+0
Lines	ORA CXM0P,X
	STA $00,Y
	EOR INTIM
	AND #$0F		; keep sort of within sound regs
	TAY
	LDA CLK+1
	EOR CLK+0
	STA $14,Y		; on top of the sound regs
	
ChkTim	LDA INTIM
	BPL Top
	INC CLK+0
	BNE TimDon
	INC CLK+1
	INC CLK+1
	BNE TimDon
	INC CLK+2
TimDon	STA VSYNC
	STA WSYNC
	STA WSYNC
	STA WSYNC
	STA VSYNC
	INX
	STA CXCLR
	BVC Reset		; This always loops
	
	ORG $FFFC
	.word Init
	.word Init
